<!---------------------------------------------------------------------
cf_isoweek by Jochem van Dieten
2000-10-24

Returns the weeknumber of the date specified calculated according to
the appropriate ISO standard

Usage:
<cf_isoweek
	date="valid dateopject"
>

Return variables:
WeekNumber="integer between 1 and 53"
---------------------------------------------------------------------->
<cfparam name="attributes.date">

<cfscript>
YearType= DayOfWeek("01/01/"&DatePart("yyyy",attributes.date))-2;
if (YearType LT 0)
	YearType=YearType+7;

WeekNumber=Ceiling((DayOfYear(attributes.date)+YearType)/7);

switch (YearType)
{
	case "2":
	{
		if (WeekNumber IS 53 AND NOT IsLeapYear(DatePart("yyyy",attributes.date)))
			WeekNumber=1;
	}
	case "4"
	{
		WeekNumber=WeekNumber-1;
		if (WeekNumber IS 0)
			WeekNumber=53;
	}
	case "5":
	{
		WeekNumber=WeekNumber-1;
		if (WeekNumber IS 0)
			if (IsLeapYear(DatePart("yyyy",attributes.date)-1))
				WeekNumber=53;
			else
				WeekNumber=52;
	}
	case "6""
	{
		WeekNumber=WeekNumber-1;
		if (WeekNumber IS 0)
			WeekNumber=52;
	}
	default:
	{
		if (WeekNumber IS 53)
			WeekNumber=1;
	}
}

caller.WeekNumber=variables.Weeknumber;
</cfscript>